/**
 * flash10patcher.c
 *
 * quickly hacked together by SvOlli
 * distributed under the terms of the GPL
 */
 
#include <stdio.h>
#include <stdlib.h>

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <string.h>

static const char *readfile = "libflashplayer.so";
static const char *writefile = "patched.libflashplayer.so";
static const unsigned int magic2_4 = 0x0d696914;
static const unsigned int magic2_3 = 0x0d696913;
static const char *glibc2_4 = "GLIBC_2.4";
static const char *glibc2_3 = "GLIBC_2.3";

int main()
{
   int fd;
   int size;
   int bytes;
   char *buffer;
   char *c;
   int strsize = strlen( glibc2_4 ) + 1;

   printf( "flash10patcher 0.2\nreading %s\n", readfile);
   
   fd = open( readfile, O_RDONLY );
   if( fd < 0 )
   {
      perror( "error opening file for reading" );
      exit(1);
   }
   size = lseek( fd, 0, SEEK_END );
   if( size < 0 )
   {
      perror( "error seeking end of file" );
      exit(1);
   }
   lseek( fd, 0, SEEK_SET );
   printf( "%s size: %d\n", readfile, size );
   buffer = (char*)malloc( size );
   for( c = buffer; c < buffer + size; )
   {
      bytes = read( fd, c, size + buffer - c );
      if( bytes < 0 )
      {
         perror( "error reading chunk" );
         exit(1);
      }
      c += bytes;
   }
   close( fd );
   
   printf( "replacing magic code 0x%08x with 0x%08x\n", magic2_4, magic2_3 );
   for( c = buffer; c < buffer + size; c += sizeof(int) )
   {
      if( magic2_4 == *(unsigned int*)c )
      {
         *(unsigned int*)c = magic2_3;
         printf("replaced at 0x%08x\n",(unsigned int)(c-buffer));
      }
   }
   printf( "replacing id string \"%s\" with \"%s\"\n", glibc2_4, glibc2_3 );
   for( c = buffer; c < buffer + size - strsize; c++ )
   {
      if( !strncmp( c, glibc2_4, strsize ) )
      {
         memcpy( c, glibc2_3, strsize );
         printf("replaced at 0x%08x\n",(unsigned int)(c-buffer));
      }
   }
   
   printf( "writing %s\n", writefile );
   fd = open( writefile, O_WRONLY | O_CREAT, 0666 );
   if( fd < 0 )
   {
      perror( "error opening file for writing" );
      exit(1);
   }
   for( c = buffer; c < buffer + size; )
   {
      bytes = write( fd, c, size + buffer - c );
      if( bytes < 0 )
      {
         perror( "error writing chunk" );
         exit(1);
      }
      c += bytes;
   }
   close( fd );
   
   return 0;
}
